<?php

function MakeFidSequence($start_id, $num_of_items)
{	global $checkedfids;

	$end_id=$start_id+$num_of_items;
	$x=$start_id;
	$checkedfids=array();
	while ($x<$end_id)
	{	array_push($checkedfids, $x);
		
		$x++;
	}
}

function ExecuteMassEdit($typeofmassedit="fb", $start_id=0, $num_of_items=0)
{	global $handle, $filesdb_name, $error, $warning, $notif, $tags_changed, $arr_fids, $making_tns,  $affected_tables, $checkedfids, $dbtags, $tag_fileids, $queries_issued, $tqueries_issued, $editquery, $arr_needed_tagstrings, $editquery_part2, $needed_tagstrings, $imagetablequery, $editortempopen, $move_actual_files, $allow_file_move, $updating_image_details, $making_delete_queries, $update_locs_on_record, $allow_file_loc_updates, $editedfids, $movepath, $catnames_and_nums, $affecteditems, $imagequery_part2, $editqueriesissued, $filesdb_allow_allresults_mass_edit_command, $allow_page_mass_edit_command_in_fb, $when_moving_dir_only_update_first_level_of_dir_items, $max_tn_width, $max_tn_height, $tnableimageformats, $imquery_part2, $destdisk, $allow_file_loc_updates_to_use_other_disks, $allow_move_to_other_disks, $nowtimestamp, $imagewidth, $imageheight, $imagearea, $aspectratio, $reverse_aspectratio, $wideortall, $showthumbnail, $hasthumbnail, $deletequery_path, $move_tns_instead_of_copying, $customsqlquery;

$nowtimestamp=GetNowTimestamp();
	$nowtimestamp=EncloseOrNull($nowtimestamp, "'");
		
	$queries_issued="";
	if (!$affecteditems)
	{
		$affecteditems="checkeditems";
	}
	if ($typeofmassedit=="fb")
	{
		$editquery=$_POST[editquery];
		if (!$editquery)
		{	$error="no edit query";
			return false;
		}
	}
	if ($typeofmassedit=="fb" || $typeofmassedit=="lister")
	{	
		$editquery_part2=ParseEditQuery($editquery);
	}
	
	//echo $updating_image_details;
	
	if ($imagetablequery)
	{
		$editimagequery_part = ", ImageInfo ";
	}
	
	$affected_tables=array_unique($affected_tables);

	if ($typeofmassedit!="adder")
	{
		GetCheckedFids();
	}
	else
	{	MakeFidSequence($start_id, $num_of_items);
	}
	
	//Adder - automatically affects all results, but uses "checkeditems"
		//with an array generated containing all ids...
	//Lister - a choice between checked, page, and all results.
	//File browser - all and page amount to the same thing, but,
		//we don't want to encourage the user to use the all command
		//too blithely, so, we toss the user a warning if they use all.
		//If either command is used, affecteditems changed to thispageonly so it reads the 
		//fids posted by the filebrowser rather than asking the db.
	
	switch ($typeofmassedit)
	{	case "lister": break;

		case "adder": 
			if ($affected_items=="thispageonly" || $affecteditems=="allresults")
			{
				$warning="page and allresults commands not needed";
				
			}
			$affecteditems="checkeditems";
			break;

		case "fb": 
			
			if ($affecteditems=="thispageonly")
			{	if (!$allow_page_mass_edit_command_in_fb)
				{	$dontexecutequery=true;
					$error="page command currently forbidden in fb";
					return false;
				}
				$warning="remem to delete thispageonly command";
				
				$affecteditems="thispageonly";
			} 
			else if ($affecteditems=="allresults")
			{
				$warning="allresults command discouraged";
				
				$affecteditems="thispageonly";
			} 
			break;
	}
	
	if ($affecteditems=="checkeditems")
	{
		$numofcheckedfids=count($checkedfids);
		$editedfids=$checkedfids;
		$checkedfids=implode(", ", $checkedfids);
		$numofaffected=$numofcheckedfids;
		if ($numofcheckedfids==0)
		{	
			$dontexecutequery=true;
			$editortempopen=true;
			$error="no checked files";
			return false;
		}
		$wherequerypart="WHERE fileinfo.file_id IN ($checkedfids) ";
		$imwherequerypart="WHERE imageinfo.file_id IN ($checkedfids)";
		$tagwherequerypart=$wherequerypart;
		$limitquerypart = "LIMIT $numofcheckedfids";
		
		$taglimitquerypart=$limitquerypart; //? from orig lib masseditor
	}
	else if ($affecteditems=="thispageonly")
	{	$editedfids=$arr_fids;

		$numofeditedfids=count($editedfids);
		$numofaffected=$numofeditedfids;
		$checkedfids=implode(", ", $editedfids); //$pagefids
		$wherequerypart="WHERE fileinfo.file_id IN ($checkedfids)";
		$imwherequerypart="WHERE imageinfo.file_id IN ($checkedfids)";
		$tagwherequerypart=$wherequerypart;
		$limitquerypart = "LIMIT $numofeditedfids";	
	}
	else if ($affecteditems=="allresults")
	{	if (!$filesdb_allow_allresults_mass_edit_command)
		{	$dontexecutequery=true;
			$error="allresults command forbidden";
			return false;
		}
		if ($customsqlquery)
		{	$dontexecutequery=true;
			$error="allresults command forbidden with customsql";
			return false;
		}
		if ($typeofmassedit=="lister")
		{	$editedfids=$arr_fids;
			$limitquerypart="";
			global $tagmapquery_part, $imagequery_part, $where, $findimages_querypart, $findtags_querypart, $andquerypart, $hidethistuff, $query_part2;
			$imwherequerypart="WHERE imageinfo.file_id IN (";
			
			$tablequerypart="FileInfo$tagmapquery_part $imagequery_part";
			
			$wherequerypart = "$where $findimages_querypart $findtags_querypart $andquerypart $hidethistuff $query_part2";
		}
		else
		{	$dontexecutequery=true;
			$error="this error should never be reached";
			return false;
		}
	}
	else
	{	$dontexecutequery=true;
		$error="ARGH";
		return false;
	}

	//Next, we handle the tags and other things that require additional fiddling beyond
	//what the ParseEditQuery function carries out on its own.
		
	if ($move_actual_files && $update_locs_on_record)
	{	$dontmove=true;
		$error = "can't both move and uplocrec";
		$dontexecutequery=true;
		
		return false;
	}
	if ($move_actual_files && $allow_file_move!="yes")
	{	$dontmove=true;
		$error = "move not allowed";
		$dontexecutequery=true;
		
		return false;
	}
	
	if ($update_locs_on_record && $allow_file_loc_updates!="yes")
	{	$dontmove=true;
		$error = "uplocrec not allowed";
		$dontexecutequery=true;
		
		return false;
	}
				

		//Start of big long extra data retrieval blurb
		if ( 
				($tags_changed && !$dontexecutequery) //tags
				|| 
				($making_tns && !$dontexecutequery) //making thumbnails
				|| 
				($move_actual_files && $allow_file_move=="yes" && !$dontexecutequery) 
						//moving files, if moving files is allowed
				|| ($updating_image_details && !$dontexecutequery) 
						//updating image details
				|| ( $making_delete_queries && !$dontexecutequery)
						//outputting, but not executing, delete queries
				|| ($update_locs_on_record && $allow_file_loc_updates=="yes" 
					&& !$dontexecutequery)
						//a lot like moving files, but without actually moving them -
							//just editing their records in the database as if you're
							//moving them.
			)
		//So, if any of the above is going on...
		//Then we have to retrieve all the affected files' ids, at least... and likely,
		//other details as well.
		{	
			if ($tags_changed)
			{
				require ("../lib-tags.php");
				//we figure out what tagtypes are needed, and which tags are
				//going to be added, and which taken out.
				GetTagtypesAndTagsNeeded();
			}
			
			if ($making_tns || $updating_image_details || $move_actual_files || $update_locs_on_record)
			{
				if ($making_tns || $updating_image_details)
				{	require ("../lib-files.php");
					
					//$needed_imfields=array("hasthumbnail", "showthumbnail");
					
				//	$tempimagetablequerypart=", imageinfo ";
					//$tempimageidpart1=" AND fileinfo.file_id = imageinfo.file_id ";
					
					//$join=" left join imageinfo on fileinfo.file_id = imageinfo.file_id";
				}
				$notif="edit exec";
				$needed_fields=array("file_id", "disk", "parentdirs", "filename", "ext");
				if ($move_actual_files || $update_locs_on_record)
				{	array_push($needed_fields, "paired");
					array_push($needed_fields, "pairedname");
					array_push($needed_fields, "itemtype");
				}
				if ($making_tns && $useprevdbthumbs)
				{	array_push($needed_fields, "prevdb_file_id");
				}
			}
			else
			{	$needed_fields=array("file_id");
			}
			
			foreach ($needed_fields as $field)
			{	$sqlfields .= "FileInfo.$field, ";
			}
			if ($making_tns || $updating_image_details)
			{
				//foreach ($needed_imfields as $field)
				//{	$sqlfields .= "ImageInfo.$field, ";
				//}
				//$sqlfields .= substr($imsqlfields, 0, -2);
			}
			$sqlfields=substr($sqlfields, 0, -2); // comma removed
			
			$thiswherequerypart=$wherequerypart;
			
			if ($affecteditems=="allresults")
			{
				$qtoissue="SELECT $sqlfields $needed_tagstrings from $tablequerypart $tempimagetablequerypart $join $thiswherequerypart $tempimageidpart1 GROUP BY fileinfo.file_id";
			}
			else if ($affecteditems=="thispageonly" || $affecteditems=="checkeditems")
			{	$qtoissue="SELECT $sqlfields $needed_tagstrings from fileinfo $tempimagetablequerypart $imageinfo $join $thiswherequerypart GROUP BY fileinfo.file_id ";
			}//$tempimageidpart1  group by
			//echo " Gathering data: <p> $qtoissue <p>";
			
			
			/*if ($affecteditems=="checkeditems")
			{	$qtoissue="SELECT FileInfo.file_id $needed_tagstrings from fileinfo $wherequerypart";
			}*/

			$queries_issued .= "$qtoissue<p>";

			$q_result = mysql_query($qtoissue,$handle) or die(mysql_error());
			
			$numofrecords=mysql_numrows($q_result);
			//echo "Num: $numofrecords ";
			//PrintQueryResultGrid($q_result, array("file_id", "hasthumbnail") );
			
			$Insert_ImageDetails_querystart = "REPLACE INTO
	ImageInfo (file_id, width, height, area, aspectratio, reverse_aspectratio, wideortall, showthumbnail, hasthumbnail) VALUES ";
			$numofaffected=0;
			$numofdelids=0;
			$new_wherequerypart = "WHERE fileinfo.file_id IN (";
			$new_limit=0;
			$movemsg="<span class='error'>";
			
			while ($info = mysql_fetch_array($q_result) )
			{	$numofaffected++;
				
				foreach ($needed_fields as $var)
				{	${$var}=$info[$var];
				}
				
				if ($making_delete_queries)
				{	$delete_ids .= "$file_id, ";
					$numofdelids++;
				}
				
				if ($tags_changed)
				{
					foreach($arr_needed_tagstrings as $thistagstring)
					{	$dbtags[$file_id][$thistagstring]=$info[$thistagstring];
					}
					$tag_fileids[$file_id]=$file_id;
				}
				
				
				//Start of long file-move portion.  The files are handled on an item-by-item
				//basis, since it's possible a few moves won't be successful.
					
				if ( ( ($move_actual_files && $allow_file_move=="yes" ) || ($update_locs_on_record && $allow_file_loc_updates=="yes") )  )
				{	$dontmove=false;

					$pairedorigpath="";
					$pairedfoltomove=false;
					$pairedmoveworked=false;
					$pairedfinaldest=false;
					$moveworked=false;
					
					
					$origpath=$disk . ":/";
					
					if ($parentdirs || $parentdirs=="0")
					{	$origpath .= $parentdirs . "/";
					}
					$origpath .= $filename;

					if ($ext || $ext=="0")
					{	$origpath .= ".$ext";
					}

					if ($paired=="y" && $itemtype=="File" && $pairedname)
					{	
						$pairedfoltomove=true;
						
						$pairedorigpath=$disk . ":/";
						if ($parentdirs || $parentdirs=="0")
						{	$pairedorigpath .= $parentdirs . "/";
						}
						$pairedorigpath .= $pairedname;

					}
					
					if ($destdisk)
					{	
						if ( ($move_actual_files && $allow_move_to_other_disks=="yes" ) || ( $update_locs_on_record && $allow_file_loc_updates_to_use_other_disks=="yes" ) )
						{	$thedisk=$destdisk;	
						}
						else if ( ($move_actual_files && $allow_move_to_other_disks!="yes") || ($update_locs_on_record && $allow_file_loc_updates_to_use_other_disks!="yes") )
						{	
							if ($destdisk!=$disk)
							{	$dontmove=true;
								$showdiskmoveforbidmsg=true;
							}
							$thedisk=$disk;
						}
					}
					else
					{	$thedisk=$disk;
						$destdisk=$disk;
					}
					$destpdirs = $thedisk . ":/" . $movepath;
					
					$finaldest=$thedisk . ":/";
					if ($movepath || $movepath=="0")
					{	$finaldest .= $movepath . "/";
					}
					$finaldest .= $filename;
					
					if ($ext || $ext=="0")
					{	$finaldest .= ".$ext";
					}
					if ($pairedfoltomove)
					{	
						$pairedfinaldest = $thedisk . ":/";
						if ($movepath)
						{	$pairedfinaldest .= $movepath . "/";
						}
						$pairedfinaldest .= $pairedname;
					}
					
					if (!$update_locs_on_record) 
						//If we're only updating file rec locs and not actually moving files,
						//less error checking is needed.
					{
						if ($paired=="y" && $itemtype=="Dir")
						{	$dontmove=true;
							$movemsg .= "<li>Don't move paired fols like $origpath, move the file it's paired with instead.";
						}
						else
						{
							if (!file_exists($origpath) )
							{	$dontmove=true;
								$movemsg .= "<li>Can't move $origpath - no file there";
							}
							if (file_exists($origpath) && $itemtype=="File" && !is_file($origpath) )
							{	$dontmove=true;
								$movemsg .= "<li>Can't move $origpath - the DB says this item's itemtype is File, but this item is not in fact a file.";
							}
							if (file_exists($origpath) && $itemtype=="Dir" && !is_dir($origpath) )
							{	
								$dontmove=true;
								$movemsg .= "<li>Can't move $origpath - the DB says this item's itemtype is Dir, but this item is not in fact a directory.";
							}
							if ($paired=="y" && !file_exists($pairedorigpath) )
							{	$dontmove=true;

								$movemsg .= "<li>Can't move paired fol $pairedorigpath - nothing there";
							}
							if (!file_exists($destpdirs))
							{	$dontmove=true;
								$movemsg.="<li>Can't move $origpath - nonexistent destination folder: $destpdirs";
							}
						
							if (file_exists($finaldest))
							{	$dontmove=true;
								$movemsg .= "<li>Can't move $origpath - a file already exists at $finaldest";
							}
							if ($paired=="y" && file_exists($pairedfinaldest))
							{	$dontmove=true;
								$movemsg .= "<li>Can't move paired fol $pairedorigpath - a file already exists at $pairedfinaldest";
							}
						
							if ($itemtype=="Dir")
							{	if ($destdisk!=$disk)
								{	$dontmove=true;
									$movemsg .= "<li>Can't move folder $origpath to a different disk, since PHP's rename function can't handle that.";
								}
							}
							if ($paired=="y" && $pairedfoltomove)
							{	if ($destdisk!=$disk)
								{	$dontmove=true;
									$movemsg .= "<li>Can't move paired folder $pairedorigpath to a different disk, since PHP's rename function can't handle that.";
								}
							}
						}
					}
					
					if ( ($move_actual_files && $allow_move_to_other_disks!="yes") && $showdiskmoveforbidmsg)
					{	$movemsg = "<span class='error'><li>Didn't move $origpath since transfer to any other disk (in this case $destdisk) is forbidden.";
					}
					if ( ($update_locs_on_record && $allow_file_loc_updates_to_use_other_disks!="yes" ) && $showdiskmoveforbidmsg)
					{	$movemsg = "<span class='error'><li>Didn't update $origpath since updating file locations on record to use any other disk (in this case $destdisk) is forbidden.";
					}
					
					if (!$dontmove)
					{						
						if (!$update_locs_on_record)
						{	$moveworked=rename($origpath, $finaldest);
						}
						else if ($update_locs_on_record)
						{	$moveworked=true;
						}
						
						if ($moveworked)
						{	
							if ($pairedfoltomove)
							{									
								if (!$update_locs_on_record)
								{	$pairedmoveworked=rename($pairedorigpath, $pairedfinaldest);
								}
								else if ($update_locs_on_record)
								{	$pairedmoveworked=true;
								}
								
								if (!$pairedmoveworked)
								{	$moveworked=false;
									$movebackworked=rename($finaldest, $origpath);
									$movemsg .= "<li>Couldn't move paired folder $pairedorigpath, moved original file back";
									$dontmove=true;
								}
							}
						}
						else
						{	$movemsg .= "<li>Couldn't move $origpath";
							$dontmove=true;
						}
						
					}
					if (!$dontmove)
					{	if ($moveworked)
						{	$new_wherequeryids .= "$file_id, ";
							
							$new_limit++;
							if (!$editqueryparentdirsadded)
							{
								$editquery_part2 .= SimpleEditQuery("fileinfo", "parentdirs", $movepath);
								$editqueryparentdirsadded=true;	
							}

							if ($destdisk!=$disk && 
									(
										($move_actual_files 
										&& 
										$allow_move_to_other_disks=="yes") 
										|| 
										( $update_locs_on_record 
										&&		
							$allow_file_loc_updates_to_use_other_disks=="yes" ) 
									) 
								)
							
							{	if (!$editquerydiskadded)
								{
									$editquery_part2 .= SimpleEditQuery("fileinfo", "disk", $destdisk);
									$editquerydiskadded=true;
								}
							}
							
							if ($itemtype=="Dir")
							{	$containedfileupdatequery="UPDATE fileinfo SET whenmodified=$nowtimestamp, ";
								
								$containedfilereplacequery="UPDATE fileinfo SET whenmodified=$nowtimestamp, ";
								
								if (
										($move_actual_files 
										&& 
										$allow_move_to_other_disks=="yes") 
										|| 
										( $update_locs_on_record 
										&&		
							$allow_file_loc_updates_to_use_other_disks=="yes" ) 
									)
								{	
									if ($destdisk!=$disk)
									{	$cleandestdisk=$destdisk;
										CleanInput($cleandestdisk);
										$containedfileupdatequery .= "disk='$cleandestdisk', ";
										$containedfilereplacequery .= "disk='$cleandestdisk', ";
									}
								}
								$containedfileupdatequery .= "parentdirs='";
								$containedfilereplacequery .="parentdirs=REPLACE(parentdirs, \"";
								
								if ($movepath)
								{	$cleanmovepath=$movepath;
									CleanInput($cleanmovepath);
									$containedfileupdatequery .= "$cleanmovepath/";
									$replacequerymovepath = "$cleanmovepath/";
								}
								
								$cleanfilename=$filename;
								CleanInput($cleanfilename);
								$containedfileupdatequery .= "$cleanfilename' where parentdirs='";
								if ($parentdirs || $parentdirs=="0")
								{	$cleanparentdirs=$parentdirs;
									CleanInput($cleanparentdirs);
									$containedfileupdatequery .= "$cleanparentdirs/";
									$containedfilereplacequery .= "$cleanparentdirs/";
								}
								$containedfilereplacequery .= "$cleanfilename\", \"$replacequerymovepath";
								$containedfilereplacequery .= "$cleanfilename\") ";
								
								$cleandisk=$disk;
								CleanInput($disk);
								$containedfileupdatequery .= "$cleanfilename' and disk='$cleandisk'";
								$containedfilereplacequery .= " where parentdirs like '";
								
								if ($parentdirs || $parentdirs=="0")
								{	$containedfilereplacequery .= "$cleanparentdirs/";
								}
								$containedfilereplacequery .= "$cleanfilename%' and disk='$cleandisk'";
								if ($when_moving_dir_only_update_first_level_of_dir_items)
								{
							
									$containedqres = mysql_query($containedfileupdatequery,$handle) or die(mysql_error());
									$edit_queriesissued .= "Containedfileupdatequery: $containedfileupdatequery";
									$queries_issued .= "Containedfileupdatequery: $containedfileupdatequery";
								}
								else
								{
									
									$containedqres = mysql_query($containedfilereplacequery,$handle) or die(mysql_error());
									$edit_queriesissued .= "<p><b>Containedfilereplacequery:</b> $containedfilereplacequery";
									$queries_issued .= "<p><b>Containedfilereplacequery:</b> $containedfilereplacequery";
								}
								//echo $containedfilereplacequery;
							}
						}
						if ($pairedfoltomove && $pairedmoveworked)
						{	
							$containedfileupdatequery="UPDATE fileinfo SET whenmodified=$nowtimestamp, ";
							$movepairedfolquery="UPDATE fileinfo set whenmodified=$nowtimestamp, ";
							if ($destdisk!=$disk && (($move_actual_files 
										&& 
										$allow_move_to_other_disks=="yes") 
										|| 
										( $update_locs_on_record 
										&&		
							$allow_file_loc_updates_to_use_other_disks=="yes" ) ) )
							{	
								$cleandestdisk=$destdisk;
								CleanInput($cleandestdisk);
								$movepairedfolquery .= "disk='$cleandestdisk', ";
								$containedfileupdatequery .= "disk='$cleandestdisk', ";
							}
							$containedfileupdatequery .= "parentdirs='";
							if ($movepath)
							{	$cleanmovepath=$movepath;
								CleanInput($cleanmovepath);
								$containedfileupdatequery .= "$cleanmovepath/";
								$movepairedfolquery .="parentdirs='$cleanmovepath'";
							}
							else
							{	$movepairedfolquery .="parentdirs=null";
							}
							$cleanpairedname=$pairedname;
							CleanInput($cleanpairedname);
							$containedfileupdatequery .= "$cleanpairedname' where parentdirs='";
							$movepairedfolquery .=" where ";
							if ($parentdirs || $parentdirs=="0")
							{	$cleanparentdirs=$parentdirs;
								CleanInput($cleanparentdirs);
								$containedfileupdatequery .= "$cleanparentdirs/";
								$movepairedfolquery .="parentdirs='$cleanparentdirs'";
							}
							else
							{	$movepairedfolquery .="isnull(parentdirs)";
							}
							$cleandisk=$disk;
							CleanInput($disk);
							$containedfileupdatequery .= "$cleanpairedname' and disk='$cleandisk'";
							$cleanpairedname=$pairedname;
							CleanInput($cleanpairedname);
							$movepairedfolquery .= " and filename='$cleanpairedname'";
							$movepairedfolquery .= " and disk='$cleandisk' LIMIT 1";
							if ($allow_pairedfol_content_updates)
							{	//echo $containedfileupdatequery;
							}
						//	echo "<p>Movepairedfolquery: $movepairedfolquery ";
							
							$movepairedfolquery_result=mysql_query($movepairedfolquery,$handle) or die(mysql_error());
							
							$edit_queriesissued .= "<p><b>Movepairedfolquery:</b> $movepairedfolquery";
							$queries_issued .= "<p><b>Movepairedfolquery:</b> $movepairedfolquery";
									
							if ($allow_pairedfol_content_updates)
							{	
								$containedqres = mysql_query($containedfileupdatequery,$handle) or die(mysql_error());
							}
							//echo "Issuing movepairedfolquery ";
							if ($allow_pairedfol_content_updates)
							{	//echo "and containedfileupdatequery ";
							}						
						}
						
					}
					else if ($dontmove)
					{	$numofaffected--;
					}

					DisplayWithNotif($movemsg, 3);
				}
				
				//End of file-move portion.

				
				//Start of updating image-details portion.
				if ($updating_image_details)
				{	
					//foreach ($needed_imfields as $var2)
					//{	${$var2}=$info[$var2];
					//}
					$rawext="";
					//Below line needs fixing
					$thispath=$disk . ":/" . $parentdirs . "/" . $filename;
					if ($ext || $ext=="0")
					{	$thispath .= ".$ext";
						$rawext=$ext;
						$lowercasext=strtolower($ext);
					}
					if ($making_tns)
					{	
						if ($ext || $ext=="0")
						{	
							if ($lowercasext=="bmp" && !$bmp_library_included)
							{	require ("../lib-bmp.php");
								$bmp_library_included=true;
							}
						}
					}
					//if ($hasthumbnail=="n" || !$hasthumbnail)
				//	
					//{	
						if ($useprevdbthumbs)
						{	$destid=$prevdb_file_id;
						}
						else
						{	$destid=$file_id;
						}
						if ($making_tns)
						{	$madetn=MakeThumbnail($thispath, $rawext, $destid);
						}
						if ( ($making_tns && $madetn) || !$making_tns )
						{	
							$prevhasthumbnail=$hasthumbnail;
							
							UnsetFileDetails();
							UnsetImageDetails();
							
							$filexists=GetFileDetails($thispath);
						
							
							if ($filexists)
							{	EncloseOrNullImageDetails();
								//if ($prevhasthumbnail=="n")
							//	{
									$q = "$Insert_ImageDetails_querystart ($file_id, $imagewidth, $imageheight, $imagearea, $aspectratio, $reverse_aspectratio, $wideortall, $showthumbnail, $hasthumbnail)";
									$qres = mysql_query($q,$handle) or die(mysql_error());	//whenmodified junk
								//}
							//	else
							//	{
								//	$q="UPDATE imageinfo set hasthumbnail='y' where file_id=$file_id LIMIT 1";
								//}
							//echo "Q: $q ";
								//$qres = mysql_query($q,$handle) or die(mysql_error());	//whenmodified junk
							}
						}
					//}	
				}
				//End of updating image-details portion.
				
			}//end of while loop
			
			
			$movemsg .= "</span>";
			if ($new_limit)	//If moving files, then, the limit number varies depending on how
					//many files were successfully moved...
			{
				$new_wherequeryids=substr($new_wherequeryids, 0, -2);
				
				$new_wherequerypart .= $new_wherequeryids;
				$new_wherequerypart .= ")";
				$wherequerypart=$new_wherequerypart;
				
				$thistablequerypart="fileinfo";
				$limitquerypart="LIMIT $new_limit";
				
				$numofaffected=$new_limit;
			}
			
			DisplayWithNotif($numofaffected, 2);
			
			//Start of delete-query portion
			if ($making_delete_queries)
			{	
				if ($numofdelids>0)
				{	$delete_ids=substr($delete_ids, 0, -2);	
					$deletequeries=CreateDeleteQueries($delete_ids, $numofdelids);

					$notif = "del queries created";
					
					$len=strlen($deletequeries);
					if ($len<2000)
					{
						$notifmsg2="Delete queries you can use manually:<p><pre>$deletequeries</pre>";
						DisplayWithNotif($notifmsg2, 4);
					}
					else
					{					
						if (!file_exists($deletequery_path) )
						{	mkdir($deletequery_path);
						}
						$res=time();
						$date = date("Y_m_d-H,i,s", $res);
						$delqueryfilename="$filesdb_name-DELETE_Queries-$date.txt";
						$finalpath=$deletequery_path . "/$delqueryfilename";
						OverwriteFile($finalpath, $deletequeries, true);
						$notifmsg="The delete queries are in this file:<p><a href=\"$finalpath\">$delqueryfilename</a>";
						DisplayWithNotif($notifmsg, 3);
					}
					
				}
				else
				{	//$error = "no ";
				}
			}
			//End of delete-query portion
			
		}
		//End of big long extra data retrieval blurb
		
		$editquery_part2=substr($editquery_part2, 2);
		$imagequery_part2=substr($imagequery_part2, 2);
		
		$affected_tables=array_unique($affected_tables);
		
		if ($affecteditems=="allresults")
		{	
			if ($new_limit)
			{	//PrintArr($affected_tables);
				foreach ($affected_tables as $table)
				{	if ($table=="fileinfo")
					{	$thisquerypart2="fileinfo.whenmodified=$nowtimestamp, $editquery_part2";
						$thiswherequerypart=$wherequerypart;
					}
					else
					{	$thisquerypart2=$imagequery_part2;
						$thiswherequerypart=$imwherequerypart . $new_wherequeryids . ")";
					}
					$edit_querytoissue = "UPDATE $table SET $thisquerypart2 $thiswherequerypart $limitquerypart";
					
					if (!$dontexecutequery)
					{	//echo "<p>Allrecords edit: $edit_querytoissue";
						$editqueriesissued .= "\n\n$editquery_to_issue";
						
						$notif="edit exec";
						$editortempopen=true;
						$editquery_result = mysql_query($edit_querytoissue,$handle) or die(mysql_error());
						$numofaffected=mysql_affected_rows();
						
						DisplayWithNotif($numofaffected, 2);
					}
				}
			}
			else
			{
				$fileinfopresent=in_array("fileinfo", $affected_tables);
				$imageinfopresent=in_array("imageinfo", $affected_tables);
			
				if ($fileinfopresent)
				{	//echo "Fileinfopresent ";
				}
				if ($imageinfopresent)
				{	//echo "imageinfopresent ";
				}
				if ( $fileinfopresent || $imageinfopresent )
				{	
					if ( $imageinfopresent && $fileinfopresent )
				
					{	$thisquerypart2 = "fileinfo.whenmodified=$nowtimestamp, $editquery_part2 , $imagequery_part2 ";
						//echo "Thisquerypart2 : $thisquerypart2 ";
						$thistablequerypart="$tablequerypart, ImageInfo";
					}
					else if ($fileinfopresent && !$imageinfopresent)
					{
						$thisquerypart2="fileinfo.whenmodified=$nowtimestamp, $editquery_part2";
						$thistablequerypart=$tablequerypart;
					}
					else if ($imageinfopresent && !$fileinfopresent)
					{	$thisquerypart2="fileinfo.whenmodified=$nowtimestamp, $imagequery_part2";
						$thistablequerypart="$tablequerypart, ImageInfo";
						$tempimageidpart=" AND fileinfo.file_id = imageinfo.file_id ";
						
					}
					
						$edit_querytoissue = "UPDATE $thistablequerypart SET $thisquerypart2 $wherequerypart $tempimageidpart $limitquerypart ";
						$queries_issued .= "<p>$edit_querytoissue";
				
						//echo "<p>Allrecords edit: $edit_querytoissue";
						$editqueriesissued .= "\n\n$edit_querytoissue";
						
						if (!$dontexecutequery)
						{	$notif="edit exec";
							$editortempopen=true;
							$editquery_result = mysql_query($edit_querytoissue,$handle) or die(mysql_error());
							$numofaffected=mysql_affected_rows();
							if ($imageinfopresent)
							{	$numofaffected = "$numofaffected<br>(Might be doubled and/or wrong because of editing image data table as well as file data table)";
							}
							DisplayWithNotif($numofaffected, 2);
						}
				}
			}
		}
		else
		{	DisplayWithNotif($numofaffected, 2);
			
			foreach ($affected_tables as $table)
			{	
				if ($table=="fileinfo")
				{	$thisquerypart2="fileinfo.whenmodified=$nowtimestamp, $editquery_part2";
					$thiswherequerypart=$wherequerypart;
				}
				else
				{	$thisquerypart2=$imagequery_part2;
					$thiswherequerypart=$imwherequerypart;
				}
				$edit_querytoissue = "UPDATE $table SET $thisquerypart2 $thiswherequerypart $limitquerypart";
				
				//echo "<p>Editquerytoissue: $edit_querytoissue";
				$queries_issued .= "<p>$edit_querytoissue";
				
				$editqueriesissued .= "\n\n$edit_querytoissue";
				if (!$dontexecutequery)
				{	$notif="edit exec";
					$editortempopen=true;
					$editquery_result = mysql_query($edit_querytoissue,$handle) or die(mysql_error());
				}
			}
		}
		
		if ($tags_changed && !$dontexecutequery)	//We also have to do more update queries to update the
			//tagstrings, not only the tags alone.
		{	
			if ($typeofmassedit=="adder")
			{	IssueTagMassEditQueries($tagwherequerypart, $taglimitquerypart);
			}
			else
			{	IssueTagMassEditQueries();
			}
			$notif="edit exec";
			$queries_issued .= $tqueries_issued;
		}		
		return true;
}
?>