<?php

function ConnectAsRoot($dbname="")
{	
	global $ideasdb_active, $linksdb_active, $filesdb_active, $ideasdb_name, $filesdb_name, $linksdb_name;
	
	$handle = mysql_pconnect("localhost", "insertnamehere", "insertpasswordhere")
	or die(mysql_error());
	
	if ($dbname)
	{	mysql_select_db("$dbname",$handle) or die(mysql_error());
	}
	return $handle;

}

function DeleteColumn($table, $column)
{	global $fields, $issuequery, $query_to_issue;

	$fieldsearch = array_search ($column, $fields);

	if ($fieldsearch==true)
	{	$query_to_issue .= " DROP `$column` ,";
		$issuequery=true;
	}
}

$dropquery["Files"]="drop table Tags, FileInfo, FileTagmap, FileContents, ImageInfo";
$dropquery["Ideas"]="drop table ideainfo, ideatagmap, tags, ideaquote, idealongdesc, ideasourcenotes";
$dropquery["Links"]="drop table urldatesofcollection, urlinfo, tags, urltagmap, urllongdesc, urlsourcenotes, urlothernotes";

$createquery["idealongdesc"]="create table idealongdesc (
	idea_id int unsigned not null primary key,
    longdesc mediumtext
)";

$createquery["ideaquote"]="
create table ideaquote (
	idea_id int unsigned not null primary key,

	quote mediumtext
)
";

$createquery["ideasourcenotes"]="
create table ideasourcenotes (
	idea_id int unsigned not null primary key,
    sourcenotes text
)
";

$createquery["urlsourcenotes"]="
create table urlsourcenotes (
	url_id int unsigned not null primary key,
	sourcenotes text
)
";

$createquery["urllongdesc"]="
create table urllongdesc (
	url_id int unsigned not null primary key,
	longdesc text
)
";

$createquery["urlothernotes"]="
create table urlothernotes (
	url_id int unsigned not null primary key,
	othernotes text
)
";

function AddField($table, $fieldtype, $newcolumn, $precedingcolumn)
{
	global $fields, $issuequery, $query_to_issue;

	$fieldsearch = array_search ($newcolumn, $fields);

	if ($fieldsearch===false)
	{
		$query_to_issue .= " ADD `$newcolumn` $fieldtype AFTER `$precedingcolumn` ,";
		$issuequery=true;
	}
}

function table_exists ($table, $db)
{ 
	$tables = mysql_list_tables ($db); 
	while (list ($temp) = mysql_fetch_array ($tables))
	{
		if ($temp == $table)
		{
			return TRUE;
	   	}
	}
  	return FALSE;
}

function mysql_tables_array ($query_result)
{	
	$tables=array();
	$x=0;

	while ($info = mysql_fetch_array ($query_result) )
	{	$tables[$x]=$info[0];
		$x++;
	}
	return $tables;
}

function mysql_indexes_array ($query_result)
{
	$indexes=array();
	while ($info = mysql_fetch_array($query_result) )
	{
		$indx=$info[Column_name];
		$keyname=$info[Key_name];
		if ($keyname!="PRIMARY")
		{
			array_push($indexes, $indx);
		}
	}
	return $indexes;
	
}

function mysql_field_array( $query )
{
	$field = mysql_num_fields( $query );

	for ( $i = 0; $i < $field; $i++ )
	{
		$names[] = mysql_field_name( $query, $i );
	}
       
	return $names;
}

function AddIndex($table, $column)
{
	global $indexes, $issuequery, $query_to_issue;
	
	$indexsearch = array_search($column, $indexes);
	
	if ($indexsearch===false)
	{	$query_to_issue = " alter TABLE `$table` ADD INDEX ( `$column` ) ";
		$issuequery=true;
	}
}

function CreateIdeasDBTables()
{
	global $handle;
	$query_to_issue="
create table ideainfo (
    idea_id int unsigned not null primary key auto_increment,

	urls text,
	filepaths text,
	relatedids text,

    title tinytext,
    bundlestring text,
    maintagstring text,
	othertagstring text,
	projectstring text,
	otherbundlestring text,
	authorstring text,
	languagestring text,
	toforstring text,
	locstring text,
	originstring text,

    priority tinyint,
	rpriority tinyint,
    plausibility tinyint,

    usefulness tinyint,
    fun tinyint,
	beauty tinyint,
    necessity tinyint,
	humorousness tinyint,
	liking tinyint,
	eduval tinyint,
	quality tinyint,
	interest tinyint,

    repository enum ('n', 'y') not null,
    trivial enum ('n', 'y') not null,
    fav enum ('n', 'y') not null,
    clutterpile enum ('n', 'y') not null,
    important enum ('n', 'y') not null,

    recurrent enum ('n', 'y') not null,
    scrapbook enum ('n', 'y') not null,
    tip enum ('n', 'y') not null,
    note enum ('n', 'y') not null,
    forother enum ('n', 'y') not null,
    activity enum ('n', 'y') not null,

    forsite enum ('used', 'unused', 'n'),
    iced enum ('n', 'y') not null,
    done enum ('n', 'y') not null,
    redundant enum ('n', 'y') not null,
    todo enum ('n', 'y') not null,
    goal enum ('n', 'y') not null,
    tentative enum ('n', 'y') not null,
    question enum ('n', 'y') not null,
	quotebelow enum ('n', 'y') not null,
	temphide enum ('n', 'y') not null,
	junkpile enum ('n', 'y') not null,
	
	listitem enum ('n', 'y') not null,
	frequent enum ('n', 'y') not null,
	definite enum ('n', 'y') not null,
	
	aside enum ('n', 'y') not null,
	archive enum ('n', 'y') not null,
	
	status enum ('n', 'y') not null,
	observation enum ('n', 'y') not null,
	aesthetic enum ('n', 'y') not null,
	utilit enum ('n', 'y') not null,
	forfun enum ('n', 'y') not null,
	educational enum ('n', 'y') not null,
	humorous enum ('n', 'y') not null,
	curio enum ('n', 'y') not null,
	obsolete enum('n', 'y') not null,
	hide enum ('n', 'y') not null,
	unhide enum('n', 'y') not null,
	opinion enum('n', 'y') not null,


    whenmodified timestamp DEFAULT CURRENT_TIMESTAMP not null,
    whenadded timestamp null,

	lastread timestamp null,

      whendone timestamp null,
	whendonestring tinytext,
      donenote text,

	whenoted timestamp null,
	whenotedstring tinytext,
	othercomments text,

	finishbydate timestamp null,
	finishbydatestring tinytext,
	notesonduedate text,

	maindateyear bigint,
	maindatemonth tinyint unsigned,
	maindateday tinyint unsigned,
	maindatetime time,

	datestartyear bigint,
	datestartmonth tinyint unsigned,
	datestartday tinyint unsigned,
	datestarttime time,

	datendyear bigint,
	datendmonth tinyint unsigned,
	datendday tinyint unsigned,
	datendtime time,

	maindatenotes text,
	daterangenotes text,
	mostrecentprevdb tinytext,
	prevdb_idea_id int unsigned
)
";

//    recurrenceinterval mediumint unsigned,

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

global $createquery;
$query_to_issue=$createquery["ideaquote"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue=$createquery["idealongdesc"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue=$createquery["ideasourcenotes"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
create table ideatagmap (
    tagmap_id int unsigned not null primary key auto_increment,
    idea_id int unsigned not null,
    tag_id int unsigned not null,
	tagtypenum tinyint unsigned
)
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="

alter TABLE `ideatagmap` ADD INDEX ( `idea_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `ideatagmap` ADD INDEX ( `tag_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `ideatagmap` ADD INDEX ( `tagtypenum` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
create table tags (
    tag_id int unsigned not null primary key auto_increment,
    tag_name varchar(255) unique,
    whenadded timestamp not null
    );
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

return $query_result;
}

function CreateLinksDBTables()
{
	global $handle;
	
	$query_to_issue="
create table urldatesofcollection (
    date_id int unsigned not null primary key auto_increment,
    url_id int unsigned not null,
    timestamp timestamp not null,
    orig_datestring tinytext not null
)";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
create table tags (
    tag_id int unsigned not null primary key auto_increment,
    tag_name varchar(255) unique,
    whenadded timestamp not null
    );
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
create table urltagmap (
    tagmap_id int unsigned not null primary key auto_increment,
    url_id int unsigned not null,
    tag_id int unsigned not null,
	tagtypenum tinyint unsigned
)
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `urltagmap` ADD INDEX ( `url_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `urltagmap` ADD INDEX ( `tag_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `urltagmap` ADD INDEX ( `tagtypenum` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
create table urlinfo (
    url_id int unsigned not null primary key auto_increment,
    url text not null,

    title tinytext,
    shortdesc tinytext,
    maintagstring text,
    othertagstring text,
    projectstring text,
    bundlestring text,
	otherbundlestring text,
    authorstring text,
    languagestring text,
	toforstring text,
	locstring text,
	originstring text,

    pagetype tinytext,
    topic tinytext,

    usefulness tinyint,
    fun tinyint,
    beauty tinyint,
	humorousness tinyint,
	necessity tinyint,
	liking tinyint,
	interest tinyint,
	quality tinyint,
	eduval tinyint,
    updatefrequency tinyint,

    reasonforsaving text,
	
    repository enum ('n', 'y') not null,
    trivial enum ('n', 'y') not null,
    savedfile enum ('n', 'y') not null,
    dead enum ('n', 'y') not null,
    fav enum ('n', 'y') not null,
	maybe enum ('n', 'y') not null,
	archive enum ('n', 'y') not null,
	aside enum ('n', 'y') not null,
    forsite enum ('used', 'unused', 'n'),
    clutterpile enum ('n', 'y') not null,
    junkpile enum ('n', 'y') not null,
    important enum ('n', 'y') not null,

	aesthetic enum ('n', 'y') not null,
	utilit enum ('n', 'y') not null,
	forfun enum ('n', 'y') not null,
	educational enum ('n', 'y') not null,
	humorous enum ('n', 'y') not null,
	news enum ('n', 'y') not null,
	curio enum ('n', 'y') not null,
	frequent enum ('n', 'y') not null,
	travelog enum ('n', 'y') not null,
	archiveorg enum ('n', 'y') not null,
	notinarchiveorg enum ('n', 'y') not null,		
	aodeny enum ('n', 'y') not null,
	
    protocol tinytext not null,
    hostname tinytext not null,
    suffix tinytext,

    path text,
    dirsonly text,

    fullfilename tinytext,
    filenameonly tinytext,
    filext tinytext,

    allparams text,
    anchor text,

    username tinytext,
    password tinytext,
    port smallint unsigned,

    numofdots tinyint(1) unsigned not null,

    isdynamicurl enum ('n', 'y') not null,

    whenmodified timestamp DEFAULT CURRENT_TIMESTAMP not null,
    whenadded timestamp null,
	whenoted timestamp null,

	lastread timestamp null,
	earliest_col_date timestamp null,

	maindateyear smallint,
	maindatemonth tinyint unsigned,
	maindateday tinyint unsigned,
	maindatetime time,
		
	datestartyear smallint,
	datestartmonth tinyint unsigned,
	datestartday tinyint unsigned,
	datestarttime time,

	datendyear smallint,
	datendmonth tinyint unsigned,
	datendday tinyint unsigned,
	datendtime time,

	maindatenotes text,
	daterangenotes text,
	mostrecentprevdb tinytext,
	prevdb_url_id int unsigned
)
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

	global $createquery;
$query_to_issue=$createquery["urllongdesc"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue=$createquery["urlsourcenotes"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue=$createquery["urlothernotes"];
$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

	return $query_result;
}


function CreateFilesDBTables()
{	global $handle;

	$query_to_issue="

create table ImageInfo (
	file_id int unsigned not null primary key auto_increment,
	width smallint,
	height smallint,
	area bigint unsigned,
	aspectratio float(10,3),
	reverse_aspectratio float(10,3),
	wideortall enum ('w', 't', 's'),
	showthumbnail enum ('n', 'y') not null,
	hasthumbnail enum ('n', 'y') not null
)
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="
alter TABLE `imageinfo` ADD INDEX ( `aspectratio` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

/*
$query_to_issue="
alter TABLE `imageinfo` ADD INDEX ( `wideortall` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="
alter TABLE `imageinfo` ADD INDEX ( `width` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
alter TABLE `imageinfo` ADD INDEX ( `height` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());



$query_to_issue="
alter TABLE `imageinfo` ADD INDEX ( `reverse_aspectratio` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());
*/

$query_to_issue="

create table FileContents (
	file_id int unsigned not null primary key auto_increment,
	contents longtext
)
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

// whenmodified timestamp ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
$query_to_issue="

create table FileInfo (
    file_id int unsigned not null primary key auto_increment,

	filesize int unsigned,
	
	extcat varchar(255),
	itemtype enum ('File', 'Dir'),
	
	disknick tinytext,
	disk tinytext,
	parentdirs text,

	filename varchar(255),
	ext varchar(255),

	filelm timestamp null,
    filecr timestamp null,
	
	paired enum ('n', 'y') not null,
	pairedname tinytext,
	
	quantity int unsigned,
	
    title tinytext,
	
	bundlestring text,
    maintagstring text,
	othertagstring text,
	projectstring text,
	otherbundlestring text,
	authorstring text,
	languagestring text, 
	originstring text,
	backuplocstring text,
	toforstring text,
	
    shortdesc tinytext,
    longdesc text,
    sourcenotes text,
	
	relatedurls text,
	relatedids text,
	
	othernotes text,
	
    licensenotes text,
    licensetype tinyint(1),

    topic tinytext,

	status enum ('n', 'y') not null,
	aesthetic enum ('n', 'y') not null,
	utilit enum ('n', 'y') not null,
	educational enum ('n', 'y') not null,
	forfun enum ('n', 'y') not null,
	humorous enum ('n', 'y') not null,
	news enum ('n', 'y') not null,
	curio enum ('n', 'y') not null,
	trivial enum ('n', 'y') not null,
	unknown enum ('n', 'y') not null,
	timecap enum ('n', 'y') not null,
	irrep enum ('n', 'y') not null,
	nostalgic enum ('n', 'y') not null,
	autobio enum ('n', 'y') not null,
	datasource enum ('n', 'y') not null,
	clutterpile enum ('n', 'y') not null,
	junkpile enum ('n', 'y') not null,
	permloc enum ('n', 'y') not null,
	maybe enum ('n', 'y') not null,
	aside enum ('n', 'y') not null,
	frequent enum ('n', 'y') not null,
	essential enum ('n', 'y') not null,
	forother enum ('n', 'y') not null,
	
    contentsimported enum ('n', 'part', 'y') not null,
	depthread enum ('n', 'scarce', 'lookedover', 'scoured') not null,
	
    repository enum ('n', 'y') not null,
    fav enum ('n', 'y') not null,
    important enum ('n', 'y') not null,
    forsite enum ('n', 'unused', 'used') not null,
   
	pairedfolitem enum ('n', 'y') not null,
    deletable enum ('n', 'y') not null,
    deleted enum ('n', 'y') not null,
	obsolete enum ('n', 'y') not null,
	redundant enum ('n', 'y') not null,
	altversion enum ('n', 'y') not null,
	primar enum ('n', 'y') not null,
	hide enum ('n', 'y') not null,
	
    privacy tinyint(1),
	privacynotes text,
	
	usefulness tinyint,
    fun tinyint,
	beauty tinyint,
    necessity tinyint,
	humorousness tinyint,
	liking tinyint,
	eduval tinyint,
	quality tinyint,
	interest tinyint,
	importance tinyint,
	relimport tinyint,
	desiretoread tinyint,
	desiretokeep tinyint,
	
	updatefrequency tinyint,
	perorimper enum ('n', 'per', 'semp', 'fam', 'imper', 'ximper') not null,
	
    reasonforsaving text,
    url text,
	
	whenmodified timestamp DEFAULT CURRENT_TIMESTAMP not null,
	
    whenadded timestamp null,

	lastread timestamp null,
	importdate timestamp null,

	
	maindateyear bigint,
	maindatemonth tinyint unsigned,
	maindateday tinyint unsigned,
	maindatetime time,

	datestartyear bigint,
	datestartmonth tinyint unsigned,
	datestartday tinyint unsigned,
	datestarttime time,

	datendyear bigint,
	datendmonth tinyint unsigned,
	datendday tinyint unsigned,
	datendtime time,

	maindatenotes text,
	daterangenotes text,
	mostrecentprevdb tinytext,
	prevdb_file_id int unsigned
)

";



$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
alter TABLE `fileinfo` ADD INDEX ( `extcat` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="
alter TABLE `fileinfo` ADD INDEX ( `filelm` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


$query_to_issue="
alter TABLE `fileinfo` ADD INDEX ( `filename` )
";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());



$query_to_issue="

create table FileTagmap (
    tagmap_id int unsigned not null primary key auto_increment,
    file_id int unsigned not null,
    tag_id int unsigned not null,
	tagtypenum tinyint unsigned
)

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `filetagmap` ADD INDEX ( `file_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `filetagmap` ADD INDEX ( `tag_id` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

alter TABLE `filetagmap` ADD INDEX ( `tagtypenum` )

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

$query_to_issue="

create table Tags (
    tag_id int unsigned not null primary key auto_increment,
    tag_name varchar(255) unique,
    whenadded timestamp not null
    );

";

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

return $query_result;

}
?>