<?php

require ("../lib-abdesk.php");

CheckCookie();
session_start();

function GoBackToFormWithError($err)
{
	$_SESSION[ideasdb_adder_error]=$err;
	header("Location: multi_idea_adder_form.php");
	exit;
}

function array_idiff($array1, $array2) 
{ 
	foreach ($array1 as $key=>$element) 
	{ 
	     foreach($array2 as $key2=>$element2) 
	     { 
	         if (strtolower($element) == strtolower($element2)) 
	         { 
	             unset($array1[$key]); 
	         } 
	     } 
	} 
	$diff = array_values($array1);
	return $diff; 
}

$sessprefix="ideasdb_multiadder";
$varstoget=array("ideas", "sourcenotes", "sepmeth", "whenotedstring", "quoteorld", "revinputorder");

foreach ($varstoget as $var)
{
	$sessvar=$sessprefix . "_$var";
	$_SESSION[$sessvar]=$_POST[$var];
}

$quoteorld=$_POST[quoteorld];
$curideasdb=$_POST[curideasdb];
$lock=$_POST[lock];
$ideasdb_name=$curideasdb;

$handle=ConnectToDb($ideasdb_name);

$rawideas = ltrim($_POST[ideas]);

if (!$rawideas)
{	GoBackToFormWithError("no ideas");
	exit;
}

$sourcenotes=$_POST[sourcenotes];
$sepmeth=$_POST[sepmeth];
$revinputorder=$_POST[revinputorder];

if ($sepmeth=="parag" || $sepmeth=="astrolog")
{	$whenotedstring=$_POST[whenotedstring];
	if ($whenotedstring)
	{
		if (($timestamp = strtotime($whenotedstring)) === false) //If there's no timestamp here...
		{	GoBackToFormWithError("invalid date");
		}
		else
		{	
			$whenoted=date("Y-m-d H:i:s", $timestamp);
			CleanInput($whenotedstring);
			$finalwhenotedstring=EncloseOrNull($whenotedstring, "'");
			
			$finalwhenoted=EncloseOrNull($whenoted, "'");
			unset($whenoted);
			unset($whenotedstring);
		}
	}
	else
	{	$finalwhenoted="now()";
		$finalwhenotedstring="null";
	}
}
CleanInput($sourcenotes);

if ($sepmeth=="parag")
{	$arr_ideas=explode("\r\n\r\n", $rawideas);
}
else
{
	$arr_ideas=explode("\r\n", $rawideas);
}

$unusednum=0;

$sourcenotes=EncloseOrNull($sourcenotes, "'");

$numofideas=0;
$numoflines=count($arr_ideas);

	$linenum=0;

if ($sepmeth=="date")
{
	foreach ($arr_ideas as $line)
	{
		$periodloc=strpos($line, ".");
		$possible_date=substr($line, 0, $periodloc);
		
		if (($timestamp = strtotime($possible_date)) === false) //If there's no timestamp here...
		{
			$ideas[$numofideas] .= "\r\n$line";
		}
		else	//if there is a timestamp here...
		{	
			$numofideas++;	
			$whenotedstring[$numofideas]=EncloseOrNull($possible_date, "'");
			$whenoted[$numofideas]=date("Y-m-d H:i:s", $timestamp);
			$whenoted[$numofideas]=EncloseOrNull($whenoted[$numofideas], "'");
			$ideas[$numofideas] .= "$line";
		}
		$linenum++;
	}
}
else if ($sepmeth=="parag")
{	foreach ($arr_ideas as $line)
	{
		$numofideas++;
		
		$whenotedstring[$numofideas]=$finalwhenotedstring;
		$whenoted[$numofideas]=$finalwhenoted;
		$ideas[$numofideas] .= "$line";
	}
}
else if ($sepmeth=="astrolog")
{
	foreach ($arr_ideas as $line)
	{
		$qaloc=strpos($line, "-qa ");
		
		if ($qaloc === false) //If there's no timestamp here...
		{
			$ideas[$numofideas] .= "\r\n$line";
		}
		else
		{
			$numofideas++;
			$whenotedstring[$numofideas]=$finalwhenotedstring;
			$whenoted[$numofideas]=$finalwhenoted;
			$ideas[$numofideas] .= "$line";
			
			$datestart=$qaloc+4;
			$colonloc=strpos($line, ":");
			if ($colonloc)
			{	$thirdcharaftercolonloc=$colonloc+3;
				$aftercolonchar=substr($line,$thirdcharaftercolonloc,1);
				if ($aftercolonchar==":")
				{	$datend=$colonloc+6;
				}
				else
				{	$datend=$thirdcharaftercolonloc;
				}
				$datend -= 4;
				$possible_date=substr($line, $datestart, $datend);
			}
			else
			{	
				$possible_date=substr($line, $datestart);
			}
			$dateparts=explode(" ", $possible_date);
			
			if (!is_numeric($dateparts[0]) )
			{
				$thistimestamp=strtotime($dateparts[0]);
			
				$thismonth=date("n", $thistimestamp);
			}
			else
			{	$thismonth=$dateparts[0];
			}
			$thisday=$dateparts[1];
			$thisyear=$dateparts[2];
			$thistime=$dateparts[3];
			
			$maindateyear[$numofideas]=EncloseOrNull($thisyear, "'");
			$maindatemonth[$numofideas]=EncloseOrNull($thismonth, "'");
			$maindateday[$numofideas]=EncloseOrNull($thisday, "'");
			$maindatetime[$numofideas]=EncloseOrNull($thistime, "'");
		}
	}
}
else if ($sepmeth="datenclosed")
{	
	$datefound=false;
	$linecounter=0;
	$stillonfirstdateline=false;
	
	foreach ($arr_ideas as $line)
	{	
		if (!$datefound)
		{	
			$whitespacefree_line=trim($line);
			$whitespacefree_line=rtrim($whitespacefree_line, ".");

			if ($whitespacefree_line)
			{	if (($timestamp = strtotime($whitespacefree_line)) === false)
				{	DisplayWithError($linecounter);
					GoBackToFormWithError("invalid date on line");
					exit;
				}
				
				$datefound=true;
				$numofideas++;
				
				$originaldateline=$whitespacefree_line;
				$whenotedstring[$numofideas]=EncloseOrNull($originaldateline, "'");
				$whenoted[$numofideas]=date("Y-m-d H:i:s", $timestamp);
				$whenoted[$numofideas]=EncloseOrNull($whenoted[$numofideas], "'");
			
				$stillonfirstdateline=true;
				
			}
		}
		if ($datefound)
		{	if (!$stillonfirstdateline)
			{	$whitespacefree_line=trim($line);
				$whitespacefree_line=rtrim($whitespacefree_line, ".");
				
				if ($whitespacefree_line)
				{	
					if ($whitespacefree_line==$originaldateline)
					{	$datefound=false;
					}
				}
			}
			$ideas[$numofideas] .= "\r\n$line";
			$stillonfirstdateline=false;
		}
		$linecounter++;
	}
}


if ($revinputorder)
{	$ideas=array_reverse($ideas, true);
}

if ($sepmeth!="astrolog")
{
	$query_to_issue="INSERT INTO IdeaInfo (repository, whenotedstring, whenoted, whenadded, lastread) VALUES\n";
}
else
{	$query_to_issue="INSERT INTO IdeaInfo (repository, whenotedstring, whenoted, whenadded, lastread, maindateyear, maindatemonth, maindateday, maindatetime) VALUES\n";
}

if ($sepmeth!="astrolog")
{
	foreach ($ideas as $ideanum => $idea)
	{
	$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now()), \n";

	}
}
else
{	foreach ($ideas as $ideanum => $idea)
	{
		$query_to_issue .= "\n('y', $whenotedstring[$ideanum], $whenoted[$ideanum], now(), now(), $maindateyear[$ideanum], $maindatemonth[$ideanum], $maindateday[$ideanum], $maindatetime[$ideanum]), \n";
	}
}

echo "<html><head><title>ABDesktop Multiple Idea Adder Results</title>
<link rel=stylesheet href=\"css/i.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style><body><center>";
ListNav();
echo "<h1>ABDesktop Multiple Idea Adder Results</h1>
<p>";
$dispcurideasdb=ucwords($curideasdb);

		$query_to_issue = substr($query_to_issue, 0, -3);
		
		echo "<big>DB: $dispcurideasdb<p>
		Number of ideas: $numofideas</big><p>";
		$addmorelink="<a href=\"http://localhost/abdesk/ideas/multi_idea_adder_form.php?db=$ideasdb_name";
		
		if ($lock)
		{	$addmorelink .= "&lock=y";
		}
		$addmorelink .= "\" class='arlink'>Add More</a>";
		
		echo "$addmorelink</center><p><div id='maintext'>";
		
		//echo "Origquery: $query_to_issue" ;
		
		$origquery=$query_to_issue;
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
		$idea_id = mysql_insert_id();
		
		if ($quoteorld=="longdesc")
		{	$ideatable="longdesc";
			$notideatable="quote";
		}
		else
		{	$ideatable="quote";
			$notideatable="longdesc";
		}
		$dispideatable=ucwords($ideatable);
		$dispnotideatable=ucwords($notideatable);
		
		$ldquery = "INSERT INTO idea$ideatable (idea_id, $ideatable) VALUES ";

		$query_to_issue=$ldquery;
		
		$thisid=$idea_id;
		foreach ($ideas as $ideanum => $idea)
		{	
			CleanInput($idea);
			$longdesc=EncloseOrNull($idea, "'");
			$query_to_issue .= "($thisid, $longdesc), \n\n";
			$thisid++;
		}
		$query_to_issue = substr($query_to_issue, 0, -4);
		echo "<p><big><b>$dispideatable query:</big></b> <pre>$query_to_issue ";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
		$thisid=$idea_id;
		
		echo "<p><br><hr><p><b>Main query:</b> $origquery<p><br>";
		
		$snquery = "INSERT INTO ideasourcenotes (idea_id, sourcenotes) VALUES \n";
		$query_to_issue=$snquery;
		foreach ($ideas as $ideanum => $idea)
		{	
			CleanInput($idea);
			$longdesc=EncloseOrNull($idea, "'");
			$query_to_issue .= "\n($thisid, $sourcenotes), \n";
			$thisid++;
		}
		$query_to_issue = substr($query_to_issue, 0, -3);
		echo "<hr><p><br><b>Sourcenotes query:</b> $query_to_issue";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
		$query_to_issue="INSERT INTO idea$notideatable (idea_id, $notideatable) VALUES \n";
		$thisid=$idea_id;
		
		foreach ($ideas as $ideanum => $idea)
		{	
			
			$query_to_issue .= "\n($thisid, NULL), \n";
			$thisid++;
		}
		$query_to_issue = substr($query_to_issue, 0, -3);
		echo "<hr><p><br><b>$dispnotideatable query:</b> $query_to_issue";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
		echo "</pre><center><p>$addmorelink";
		
		echo"<p><br><br>";
		ListNav();
		
?>