<?php

$abdesktop_path="http://localhost/abdesk/";

$linksdb_active="yes";
$ideasdb_active="yes";
$filesdb_active="yes";

//Cookie settings
$cookiename="insertcookievaluehere";
$cookievalue="insertcookienamehere";


//Memory/execution time limit settings
$setphpdefaults=false;	//If set to false, these settings won't be used.
$phpmem="200M";
$phpmaxexec="240";


//Disk nickname settings

$maindisknicknames = array("Dell");
$defaultdisknick = "Dell";

/*$maindisknicknames = array("Acer");
$defaultdisknick = "Acer";*/


//Default DBs to use

$linksdb_name="abdesklinks";
$ideasdb_name="abdeskideas";
$filesdb_name="abdeskfiles";

//$linksdb_name="testlinks";
//$ideasdb_name="testideas";
//$filesdb_name="testfiles";


//Lists of all your DBs. (To add new databases to the lists, edit these arrays).
//Example line:
//$ideas_dbs=array("abdeskideas", "recipeideas");

$links_dbs=array("abdesklinks");
$ideas_dbs=array("abdeskideas");
$files_dbs=array("abdeskfiles");


//Mass editor settings
//Set these to true if you want the "allresults" edit command to work.
$linksdb_allow_allresults_mass_edit_command=false;
$ideasdb_allow_allresults_mass_edit_command=false;
$filesdb_allow_allresults_mass_edit_command=false;

$allow_page_mass_edit_command_in_fb=false; //If you want the "page" mass edit command to be
											//allowed in file browsers, set to true.

//Flle organizer stuff
$fileadder_active="yes";
$iframeheight=700;


//File mover settings
$allow_file_move=false;	//Set to "yes", not true, if you want file moving to be allowed.

$allow_move_to_other_disks=false; //I highly recommend that you keep this set to false.
								//I think I had a test folder vanish into thin air when trying to
								//move it to a different disk than their original
								//disk.   
								//Set to "yes", instead of true, if you really want 
								//to allow files to be moved to other disks.
								
$allow_file_loc_updates=false;	//Set to "yes", not true, if you want this allowed.
$allow_file_loc_updates_to_use_other_disks=false; //Set to "yes", not true, if you want this allowed.

$allow_pairedfol_content_updates=false; //useless to set to true unless you unwisely imported
										//a lot of paired fol items - cluttery files contained inside
										//folders paired with saved web files.
										
$when_moving_dir_only_update_first_level_of_dir_items=false;
	//Should be false if you're moving directories containing lots of subdirectories
	//whose contents are contained in the DB, so all the subdirs' contents' locations
	//on record will get updated properly.  
	//If it's set to true, the file mover/location updater
	//will only update the first level, without updating all the deeper subdirectories.
	//The main benefit of that is, the database doesn't have to do as much work.


//Image organizer settings
$bmp_library_installed=false; //Set to "yes" whenever you install it.
$images_per_tn_fol=2000;


//Not used
$readonly=false;


//Other stuff
$localip="127.0.0.1";
$neededip=$localip;

$allow_only_one_ip="yes";

$siteroot="/abdesk";

$webroot="http://localhost";
$mainsitepathweb=$webroot . $siteroot;

$mainsitepath=$_SERVER[DOCUMENT_ROOT] . $siteroot;

$datafol="/abdesk-data";
$maincsspath=$_SERVER[DOCUMENT_ROOT] . $datafol . "/css";
$abdeskcsspath=$mainsitepath . "/css";

$datapath=$_SERVER[DOCUMENT_ROOT] . $datafol;
$datapathweb=$webroot . $datafol;

$logfilepath=$datapath . "/log.php";

$deletequery_path=$datapath . "/delete-queries";
$backuprecent_path=$datapath . "/backup-recent";
$exportdb_path=$datapath . "/exported-db";
$filebrowser_path=$datapath . "/browsers";
$listpane_path = $filebrowser_path . "/listpane";
$tn_images_path=$datapath . "/tn";
$tn_images_path_web=$datapathweb . "/tn";


function ConnectToDb($thisdb)
{	
	global $ideasdb_active, $linksdb_active, $filesdb_active, $ideasdb_name, $filesdb_name, $linksdb_name;

	if ( ($thisdb==$ideasdb_name && $ideasdb_active=="yes") || ($thisdb == $linksdb_name && $linksdb_active=="yes") || ($thisdb == $filesdb_name && $filesdb_active=="yes") )
	{
		$handle = mysql_pconnect("localhost", "insertnamehere", "insertpasswordhere") or die(mysql_error());

		mysql_select_db("$thisdb",$handle) or die(mysql_error());
		return $handle;
	}
	else
	{	echo "Unacceptable DB name: $thisdb";
		exit;
	}
}

function MakeNeededFols($paths)
{
	foreach ($paths as $path)
	{	global ${$path};
		if (!file_exists(${$path}) )
		{	mkdir( ${$path} );
		}
	}
}

function PrintDBHeader($dbtype, $noisy=true)
{	
	$dbvarname="$dbtype" . "sdb_name";
	global ${$dbvarname};
	$dispdb=ucwords( ${$dbvarname} );
	$res="<big>DB: $dispdb</big>";
	if ($noisy)
	{	echo $res;
	}
	else
	{	return $res;
	}
	
}
function PrintDBsList($dbtype, $noisy=true)
{	
	$dbsarrname="$dbtype" . "s_dbs";
	$dbvarname="$dbtype" . "sdb_name";
	global ${$dbsarrname};
	global ${$dbvarname};
	
	$x=0;
	$res .= "<center><table>";
	foreach (${$dbsarrname} as $db)
	{	
		if ($x%7==0)
		{	$res .= "<tr><td>";
		}
		$dispdb=ucwords($db);
		$res .= "<td class='dbslist'><INPUT TYPE=RADIO NAME=\"cur" . $dbtype . "sdb\" VALUE=\"$db\" ";
		if ($db==${$dbvarname})
		{	 $res .= "checked";
			
		}
		$res .= ">&nbsp;";
		if ($db==${$dbvarname})
		{	$res .= "<b>";
		}
		$res .= "$dispdb";
		if ($db==${$dbvarname})
		{	$res .= "</b>";
		}
		$x++;
	}
	$res .= "</span></table></center>";
	if ($noisy)
	{	echo $res;
	}
	else
	{	return $res;
	}
}
function CheckOpera()
{
	$browser = $_SERVER['HTTP_USER_AGENT'];
	$opera=strpos($browser, "Opera");
	if ($opera!==false)
	//$browser=="Opera/9.21 (Windows NT 5.1; U; en)")
	{	return true;
	}
}

function GetFNExt($basename)
{	
	$dotloc=strrpos($basename, ".");
	
	if ($dotloc || $dotloc===0)
	{	$thisext=substr($basename, $dotloc+1);
		if ($dotloc!==0)
		{	$thisfn=substr($basename, 0, $dotloc);
		}
	}
	else
	{
		$thisfn=$basename;
	}
	$arr=array($thisfn, $thisext);
	return $arr;
}	

function CheckOpera921()
{
	$browser = $_SERVER['HTTP_USER_AGENT'];
	if ($browser=="Opera/9.21 (Windows NT 5.1; U; en)")
	{	return true;
	}
}

function OperaCSS()
{
	echo "	.imp, .fav, .forsite, .onsite, .freq, .repo, .pile, .trv, .redun, .trav, .bundle, .deadb, .sav, .inao, .noao, .inaou, .bigdate, .arcd, .cpile
{	border-style: ridge;
}
.catsymb
{
	font-size: x-large;
}
.scores
{	font-size: large;
}
	";
}


function GoodIP()
{	global $neededip, $allow_only_one_ip;
	$ip=$_SERVER[REMOTE_ADDR];

	if ($allow_only_one_ip=="no")
	{	return true;
	}
	
	if ($ip!=$neededip)
	{	return false;
	}
	else
	{
		return true;
	}
}

function CheckIP()
{
	if (GoodIP() )
	{
		return true;
	}
	else
	{	$logentry = "Wrong IP";
		GetLost($logentry);
		exit;
	}
}

function GetLost($logentry)
{	global $mainsitepath, $keypath, $notkeypath, $tripwire;
	$logentry = "Get Lost - " . $logentry;
	AddLogEntry($logentry);
}


function AddLogEntry($logentrytype)
{	global $logfilepath, $fnforlog;

	$ip = $_SERVER['REMOTE_ADDR'];
	$hostaddress = gethostbyaddr($ip);
	$browser = $_SERVER['HTTP_USER_AGENT'];
	$referred = $_SERVER['HTTP_REFERER'];
	$requestmethod = $_SERVER['REQUEST_METHOD'];
	$timestamp=GetNowTimestamp();
	$timestamp .= " GMT";

	if ($referred == "")

	{	$referred="Direct request";
	}

	$filetext="<?php exit; ?><li>$timestamp - $requestmethod $logentrytype
$ip - $hostaddress | $browser
Accessed: $fnforlog
Ref: $referred\n\n";

	$openthis=$logfilepath;

	AppendToFile($logfilepath, $filetext);
}

function AppendToFile($openthis, $filetext)
{
	//$openthis needs to be set equal to a file path (appropriate for internal PHP use),
	//formatted like so: C:/xampp/htdocs/AC-Mirror/blog.shtml
	
	//$filetext is set equal to whatever text the file is supposed to contain.

	$filehandle=fopen($openthis, "a");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);
	return true;
}

function CheckCookie()
{	global $cookiename, $cookievalue, $mainsitepathweb;

	CheckIP();

	if ($_COOKIE[$cookiename] != $cookievalue )
	{	$logentry="Good IP and Bad Cookie";
		GetLost($logentry);
		header("Location: $mainsitepathweb/loginform.php");
		exit;
	}
	StartTimer();
}

function StartTimer()
{	global $mtime, $starttime;
	$mtime = microtime();
	$mtime = explode(" ",$mtime);
	$mtime = $mtime[1] + $mtime[0];
	$starttime = $mtime;
}

function EndTimer()
{	 global $mtime, $starttime;
	$mtime = microtime();
   	$mtime = explode(" ",$mtime);
   	$mtime = $mtime[1] + $mtime[0];
   	$endtime = $mtime;
   	$totaltime = ($endtime - $starttime);
   echo "Created in ".$totaltime." seconds. ";
	echo memory_get_usage(); echo "</small>";//<p>";

//<!-- put this code at the bottom of the page http://www.developerfusion.co.uk/show/2058/ -->
}

function LinksNav()
{	global $abdesktop_path, $linksdb_name;
	echo "<div class='navlinks'><a href='$abdesktop_path" . "links/link_adder_form.php?db=$linksdb_name'>Add Link</a> - " . "<a href='$abdesktop_path" . "links/multi_link_adder_form.php?db=$linksdb_name'>Add Many</a> - <a href='$abdesktop_path" . "links/list-links.php?db=$linksdb_name&p=0&a=desc&g=y&n=10&o=UrlInfo.url_id%20desc&inc=rep,triv,aside,trav,maybe,arc'>Long List</a> - <a href='$abdesktop_path" . "links/list-links.php'>List Links</a> - <a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	EndTimer();
}

function FilesNav()
{	global $abdesktop_path, $filesdb_name;
	$mainlistlink="$abdesktop_path" . "files/list-files.php?p=0&db=$filesdb_name&mtnl=y&a=desc&g=y&n=15&o=fileinfo.file_id%20desc&inc=rep,triv,stat,unk,maybe,timecap,data,scour";
	
	echo "<div class='navlinks'><a href='$abdesktop_path" . "files/file_adder_form.php?db=$filesdb_name'>File Adder</a> - <a href='$mainlistlink'>Long List</a> - <a href='$abdesktop_path" . "files/list-files.php'>List Files</a>  - "

 . "<a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	EndTimer();
}

function ThumbnailPath($id, $temp=false)
{	global $tn_images_path_web, $images_per_tn_fol, $filesdb_name;
	$tnfolnum=floor($id/$images_per_tn_fol);
	$tnfolnum++;
	$res="$tn_images_path_web/$filesdb_name";
	if ($temp)
	{	$res .= "-temp";
	}
	$res .="/$tnfolnum/$id.jpg";
	return $res;
}

function DisplayThumbnail($id, $temp=false)
{	global $tn_images_path_web, $images_per_tn_fol, $filesdb_name;

	$tnfolnum=floor($id/$images_per_tn_fol);
	$tnfolnum++;
	$res="<img src=\"$tn_images_path_web/$filesdb_name";
	if ($temp)
	{	$res .= "-temp";
	}
	$res .= "/$tnfolnum/$id.jpg\" border=0>";
	return $res;
}

function IdeasNav($omitlastline=0)
{
	global $abdesktop_path, $ideasdb_name;
	echo "<div class='navlinks'><a href='$abdesktop_path" . "ideas/idea_record_editor_form.php?db=$ideasdb_name'>Add Idea</a> - <a href='$abdesktop_path" . "ideas/multi_idea_adder_form.php?db=$ideasdb_name'>Add Many</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php?p=0&db=$ideasdb_name&a=desc&plpre=y&g=y&n=10&o=IdeaInfo.idea_id%20desc&inc=rep,triv,todo,stat,list,recur,arc,ques'>Long List</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php'>List Ideas</a> - <a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	if (!$omitlastline)
	{	EndTimer();
	}
}

function ListNav()
{	global $abdesktop_path, $linksdb_name, $ideasdb_name, $filesdb_name;
	echo "<div class='navlinks'><a href='$abdesktop_path" . "links/link_adder_form.php?db=$linksdb_name'>Add Link</a> - <a href='$abdesktop_path" . "links/multi_link_adder_form.php?db=$linksdb_name'>Add Many Links</a> - <a href='$abdesktop_path" . "links/list-links.php?db=$linksdb_name&p=0&a=desc&g=y&n=10&o=UrlInfo.url_id%20desc&inc=rep,triv,aside,trav,maybe,arc'>Long Links List</a> - <a href='$abdesktop_path" . "links/list-links.php'>List Links</a><br>
	<a href='$abdesktop_path" . "ideas/idea_record_editor_form.php?db=$ideasdb_name'>Add Idea</a> - <a href='$abdesktop_path" . "ideas/multi_idea_adder_form.php?db=$ideasdb_name'>Add Many Ideas</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php?p=0&db=$ideasdb_name&a=desc&plpre=y&g=y&n=10&o=IdeaInfo.idea_id%20desc&inc=rep,triv,todo,stat,list,recur,arc,ques'>Long Ideas List</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php'>List Ideas</a><br>
	<a href='$abdesktop_path" . "files/file_adder_form.php?db=$filesdb_name'>File Adder</a> -  <a href='$abdesktop_path" . "files/list-files.php?p=0&mtnl=y&db=$filesdb_name&a=desc&g=y&n=15&o=fileinfo.file_id%20desc&inc=rep,triv,stat,unk,maybe,timecap,data,scour'>Long Files List</a> - <a href='$abdesktop_path" . "files/list-files.php'>List Files</a> - "

 . "<a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	EndTimer();
}

function CleanInput(&$inp) //To protect against SQL injection security breaches.
{
	if ( !is_numeric($inp) && !is_array($inp) )
	{	$inp = mysql_real_escape_string($inp);
	};
	if (is_array($inp) )
	{	array_walk($inp, 'CleanInput');
	}
}

function EncloseOrIsNull($varname, $value, $enclosure)
{	
	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	{	
		//$reverse_enclosure=strrev($enclosure);
		$value = "$varname = " . $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
		//Unless its first character is a zero, in which case we better enclose it.
		$zeropos=strpos($value, "0");

		if ($zeropos!==false && $zeropos===0)
		{	$value = "$varname = " . $enclosure . $value . $enclosure;
		}
		else
		{
			$value = "$varname = " . $value;
		}
		
	}
	else $value="isnull($varname)";
	return $value;
}

function GetItemType($filepath)
{	
	if ( !file_exists($filepath) )
	{	
		return false;
	}
	if ( is_file($filepath) )
	{	return "File";
	}
	if ( is_dir($filepath) )
	{	return "Dir";
	}
}

function PrintQueryResultGrid($queryresult, $varstoget)
{
	mysql_data_seek($queryresult,0);
	
	$y=0;
	$len=count($varstoget);
	
	echo "<table border><tr>";
	while ($y<$len)
	{	echo "<th>$varstoget[$y]";
		$y++;
	}

	while ( $unpublishedpost_info = mysql_fetch_array($queryresult) )
	{
		$y=0;
		echo "\n<tr>";
		while ($y<$len)
		{
			$varname=$varstoget[$y];
			${$varname} = $unpublishedpost_info[$varname];
			
			echo "<td>${$varname}";
			
			$y++;
		}
	}
	echo "</table>";
}

function GetBundlestringText($bundlestring, $class="bundle")
{	
	$arr_bundles=explode(";",$bundlestring);
	array_walk($arr_bundles, RemoveWhitespaceEtcFromTagArr);
	array_walk($arr_bundles, SpaceToNbsp);
	foreach ($arr_bundles as $thisbundle)
	{	$res .= "<span class=\"$class\">$thisbundle</span> ";
	}
	return $res;
}

function StripExtraSlashes($str)
{	return preg_replace("/(\/)+/", '/', $str);
}

function StripBackslashPeriods($string)
{
   $string=preg_replace('/[\\\\]+[\.\.]+/', '', $string);
   $string=preg_replace('/[\/]+[\.\.]+/', '', $string);

	return $string;
}

function BackslashesDetectedIn($inp)
{	if (strpos($inp, "\\")!==false)
	{
		return true;
	}
	return false;
}

function SlashDetectedIn($inp)
{	if (strpos($inp, "/")!==false)
	{
		return true;
	}
	return false;
}

function EchoWarn($inp)
{	echo "<span class='warning'>$inp</span><p>";
}

function EchoNotif($inp)
{	global $notifvarname;
	if (!$notifvarname)
	{	$notifvarname="notif";
	}
	echo "<span class='notif'>$inp</span><p>";
	$_SESSION[$notifvarname]=null;
	$_SESSION[notifdisp]=null;
	$_SESSION[notifdisp2]=null;
	$_SESSION[notifdisp3]=null;
	$_SESSION[notifdisp4]=null;
}
function DisplayWithNotif($displaythis, $num=0)
{	//echo "<p>Displaythis: $displaythis  Num: $num ";
	if (!$num)
	{	$_SESSION[notifdisp]=$displaythis;
	}
	else
	{	$notifvar="notifdisp$num";
		$_SESSION[$notifvar]=$displaythis;
	}
}

function EchoError($inp)
{	global $errorvarname;
	if (!$errorvarname)
	{	$unsetvarname="error";
	}
	else
	{	$unsetvarname=$errorvarname;
	}
	
	echo "<span class='error'>$inp</span><p>";
	$_SESSION[$unsetvarname]=null;
	$_SESSION[errdisplay]=null;
	
}

function DisplayWithError($displaythis)
{	
	$_SESSION[errdisplay]=$displaythis;
}

function br()
{	echo "<br>\n";
}

function p()
{	echo "<p>\n";
}

function OverwriteFile($openthis, $filetext, $silent=false)
{
	//$openthis needs to be set equal to a file path (appropriate for internal PHP use),
	//formatted like so: C:/xampp/htdocs/AC-Mirror/blog.shtml
	
	//$filetext is set equal to whatever text the file is supposed to contain.
	
	if (!$silent)
	{	echo "Outputting this: $openthis<br>";
	}
	
	$filehandle=fopen($openthis, "w");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);
	
	return true;
}

function EncloseOrNull($value, $enclosure)
{	
	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	{	
		//$reverse_enclosure=strrev($enclosure);
		$value = $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
		//Unless its first character is a zero, in which case we better enclose it.
		//Otherwise MySQL strips off the zero.
		$zeropos=strpos($value, "0");
		
		// && $zeropos===0
		if ($zeropos!==false)
		{	$value = $enclosure . $value . $enclosure;
		}
	}
	else $value="NULL";
	return $value;
}

function GetSessionVar($varname)
{	global $prevformname, $itemid, $dbtype;

	$dbvar="$dbtype" . "sdb_name";
	global ${$dbvar};
	
	$sessionvarname=$prevformname . "_orig_" . ${$dbvar} . "_" . "$itemid" . "_" . $varname;
	CleanInput($_SESSION[$sessionvarname]);
	$sessionvar=$_SESSION[$sessionvarname];
	return $sessionvar;
}

function MakeQueryParts($id, $varstoget)
{	global $prevformname, $itemid;

	$querypartstring="querypart_";
	$itemid=$id;
	
	foreach ($varstoget as $varname)
	{
		global ${$varname};		
		$sessionvar=GetSessionVar($varname);
		if ($sessionvar!=${$varname} )
		{
			$queryvarname=$querypartstring . $varname;
			${$queryvarname}="$varname =";
			$enclosedval=EncloseOrNull(${$varname}, "'");
			${$queryvarname} .= "$enclosedval, ";
			$allqueryparts .= ${$queryvarname};
		}
	}
	return $allqueryparts;
}

function PrintArr($arr, $text="Printed Array:")
{
	echo "<p><br><big><b>$text</b></big><p>";
	print_r($arr);
}

function array_iunique($array)
{
    return array_intersect_key($array,array_unique(array_map(strtolower,$array)));
}

function ArrRemoveEmptyValues($array)
{
	foreach($array as $key => $value)
	{
		if($value == "" || $value == " " || is_null($value)) 
		{
			unset($array[$key]);
		}
	}
	$array = array_values($array);
	return $array;
}

function RemoveWhitespaceEtcFromTagArr(&$arr)
{
	$arr=trim($arr);
	$arr=StripRN($arr);
	$arr=StripExtraMiddleSpaces($arr);
}

function GetError()
{	global $errorvarname, $error;

	if ($_SESSION[$errorvarname])
	{	$error=$_SESSION[$errorvarname];
	}
}

function StripRN($string)
{
   return preg_replace('/(\r\n)+|(\n|\r)+/', ' ', $string);
}

function StripExtraMiddleSpaces($string)
{
   return preg_replace('/\s\s+/', ' ', $string);
}

function SpaceToNbsp(&$string)
{	$string=preg_replace('/\s/', '&nbsp;', $string);
}

function MakeSQLInsertVals($varstoget)
{	
	foreach ($varstoget as $varname)
	{
		global ${$varname};

		$enclosedvarname="enclosed" . $varname;

		global ${$enclosedvarname};

		$sqlvals .= "${$enclosedvarname}, ";
		$x++;
	}
	TrimComma($sqlvals);
	return $sqlvals;
}

function EncloseOrNullAll($vars)
{
	foreach ($vars as $varname)
	{	
		global ${$varname};
		$enclosedvarname="enclosed" . $varname;
		global ${$enclosedvarname};

		${$enclosedvarname}=EncloseOrNull(${$varname}, "'");
	}
}

function GetNowTimestamp()
{	$res=time();
	$res = date("Y-m-d H:i:s", $res);
	return $res;
}

function GetTimestamp($rawdate)
{	$res = MakeIntoUnixTime($rawdate);
	$res = date("Y-m-d H:i:s", $res);
	return $res;
}

function MakeIntoUnixTime ($str)
{	
	if (!empty($str))
	{
		if (($timestamp = strtotime($str)) === false) 
		{
			GoBackToFormWithError("invalid timestamp");
			exit;
		} 
	
	return $timestamp;
	}
}

function FixCheckboxValues()
{	global $checkboxes;

	$x=0;
	$len=count($checkboxes);
	while ($x<$len)
	{	$thisbox=$checkboxes[$x];
		if ($thisbox!="y")
		{	$checkboxes[$x]="n";
		}
		$x++;
	}
}

function TrimComma(&$value)
{	$value=substr ($value, 0, -2);
}

function PrintHiddenInput($varname)
{	global ${$varname};

	if (${$varname}==false && ${$varname}!="0")
	{	return false;
	}	
	echo "<input type='hidden' name='$varname' value=\"";
	echo ${$varname};
	echo "\">\n";
}

function FixNumberboxValues()
{	global $numberboxes;
	$x=0;
	$len=count($numberboxes);
	while ($x<$len)
	{	$thisbox=$numberboxes[$x];
		if (!is_numeric($thisbox) || $thisbox===false)
		{
			unset($numberboxes[$x]);
		}
		$x++;
	}
}

function RemoveFormSessionVars($vars, $id)
{	global $prevformname, $dbtype;
	$dbvarname="$dbtype" . "sdb_name";
	global ${$dbvarname};
	foreach ($vars as $varname)
	{	
		$sessionvarname=$prevformname . "_orig_" . "${$dbvarname}" . "_" . "$id" . "_" . $varname;
		//echo "Sessionvarname: $sessionvarname $_SESSION[$sessionvarname]<br>";
		unset($_SESSION[$sessionvarname]);
		$x++;
	}	
}
function GetBrowserQueryPart($browserstart, $browserlimit)
{
	if ($browserlimit || $browserstart)
	{	if (!$browserstart || !is_numeric($browserstart) )
		{	$browserstart=0;
		}
		if (!$browserlimit || !is_numeric($browserlimit) )
		{	$browserlimit=999999999999999;
		}
		$browserquerypart="LIMIT $browserstart, $browserlimit";
		return $browserquerypart;
	}
}
function FindBadChars($str)
{	
	//$badchars=preg_match_all("/:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	//$badchars=preg_match_all("/\/|:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	//echo "Str: $str";

	$badchars=preg_match_all("/\/|:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	
	//I HATE REGULAR EXPRESSIONS!
	//Now, just because the damn thing won't notice backslashes no matter what I do,
	//we have to bother with this:
	if (BackslashesDetectedIn($str))
	{	array_push($matches[0], "\\");
	}
	
	$matchstr=implode(" ", $matches[0]);

	if ($badchars>0)
	{	DisplayWithError($matchstr);
		global $error, $fbtempopen;
		$fbtempopen=true;
		$error="badchars";
	}
}


function GetExportTNPath($id, $exportdbtn_path)
{	global $images_per_tn_fol;
	$tnfolnum=floor($id/$images_per_tn_fol);
	$tnfolnum++;
	$res=$exportdbtn_path . "/" . $tnfolnum;
	if ( !file_exists( $res ) )
	{	mkdir ($res);
	}
	$res .= "/$id.jpg";
	return $res;
}

function GetThumbnailPath($id, $temp=false)
{	global $tn_images_path, $images_per_tn_fol, $filesdb_name, $datapath;
	
	if (!file_exists( $datapath ) )
	{	
		mkdir( $datapath );
	}
	if (!file_exists($tn_images_path) )
	{	mkdir($tn_images_path);
	}
	$output_path_dirs=$tn_images_path . "/$filesdb_name";
	if ($temp)
	{	$output_path_dirs .= "-temp";
	}
	if (!file_exists($output_path_dirs) )
	{	mkdir($output_path_dirs);
	}
	
	$tnfolnum=floor($id/$images_per_tn_fol);
	$tnfolnum++;
	$output_path_dirs=$output_path_dirs . "/" . $tnfolnum;
	
	if (!file_exists($output_path_dirs) )
	{	mkdir($output_path_dirs);
	}
	$res=$output_path_dirs . "/$id.jpg";
	return $res;
}

?>