<?php

function mysql_field_array( $query )
{	//Returns an array listing the table fields present in a query result.
	$field = mysql_num_fields( $query );

	for ( $i = 0; $i < $field; $i++ )
	{
		$names[] = mysql_field_name( $query, $i );
	}
	return $names;
}

//Maybe should be MakeFileExport.  Maybe separate exporters for different DB types.
function MakeExport($fbname, $dbtype, $date)
{
	global $handle, $browser_query_result, $tagmapquery_part, $imagequery_part, $where, $findimages_querypart, $findtags_querypart, $andquerypart, $hidethistuff, $query_part2, $browserlimit, $browserstart, $fbfilesonly, $fbimsonly, $exportdb_path, $order, $customsqlquery, $fbtn, $move_tns_instead_of_copying;
	
	if ($fbfilesonly)
	{	$filesonlyquerypart="AND FileInfo.itemtype='File'";
	}
	if ($fbimsonly)
	{	$imagesonlyquerypart="AND FileInfo.extcat='Image'";
	}

	$browserquerypart = GetBrowserQueryPart($browserstart, $browserlimit);
	
	//We start by getting all the record details.  We don't need the tags or tagmap table,
//the needed tags will be created anew later during the import using the tagstrings.
//The related IDs will also be dealt with and changed to their proper new values
//by the import script.  (Once the import script is written, that is.)

	if (!$customsqlquery)
	{
		$query_to_issue = "SELECT * FROM FileInfo $tagmapquery_part $imagequery_part\n\n$where $findimages_querypart $findtags_querypart $andquerypart $hidethistuff $filesonlyquerypart $imagesonlyquerypart $query_part2 \nGROUP BY FileInfo.file_id ORDER BY $order $browserquerypart ";
		echo "<p>Export query: $query_to_issue<p>";
	}
	else
	{	$query_to_issue = "SELECT $customsqlquery ";
	}
	
	$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());
	
	//Rather than manually writing a list of the table columns, we do it automatically.
	$info_fields=mysql_field_array($query_result);
	
	//We exclude the file_id (or whatever) field, since the records will all be assigned new IDs when 
//they're imported/merged into the other database.
	$excludefields=array("idea_id", "url_id", "file_id", "tagmap_id", "tag_id", "tagtypenum", "tag_name");
	
	//tagmap_id, tag_id, tagtypenum, tag_name
	$info_insertfields=array_diff($info_fields, $excludefields);
	
	$prevdb_id_name="prevdb_$dbtype" . "_id";
	array_push($info_insertfields, "mostrecentprevdb");
	array_push($info_insertfields, "$prevdb_id_name");
	
	$info_insertfields=array_iunique($info_insertfields);
	
	$info_sqlvars=implode(", ", $info_insertfields);
	
	//Next, we process the query results and construct the SQL insert
//queries for the output.
	$numofresults=mysql_num_rows($query_result);
	$numoffilesoutput=$numofresults;
	
	$querychunk=0;
	$prevquerychunk=-1;

	$x=0;
	$semicolon="";
	$semicolon2="";
	
	$output_query=array();
	$infotablename=$dbtype . "info";
	
	$thisdbname="$dbtype" ."sdb_name";
	global ${$thisdbname};
	
	$dbname="${$thisdbname}" . "-" . $fbname . "-$numoffilesoutput" . "_Files-$date.txt";
	
	if (!file_exists($exportdb_path) )
	{	mkdir( $exportdb_path );
	}
	
	if ($fbtn)
	{
		$exportdbtn_path=$exportdb_path . "/${$thisdbname}" . "-" . "$fbname-$date-tn";
		mkdir( $exportdbtn_path );
	}
	
	$id_name="$dbtype" . "_id";
	
		
	while ($info = mysql_fetch_array($query_result) )
	{
		array_walk($info,'CleanInput');
		
		if ($prevquerychunk<$querychunk)
		{	
			$output_query[$querychunk] = "$semicolon\n\nINSERT INTO

			$infotablename ($info_sqlvars)

			VALUES\n\n";
			$prevquerychunk=$querychunk;
			$semicolon=";";
		}
		$output_query[$querychunk] .= " (";

		foreach ($info_insertfields as $field)
		{	${$field}=$info[$field];
		}
		$thisid=$info[$id_name];
		${$prevdb_id_name} = $thisid;
		$mostrecentprevdb=$fbname;

		if ($fbtn)
		{
			if ($extcat=="Image")
			{	
				$origtnpath=GetThumbnailPath($thisid);
				$dest_tnpath=GetExportTNPath($thisid, $exportdbtn_path);
				if ($move_tns_instead_of_copying=="yes")
				{	$moveworked=rename($origtnpath, $dest_tnpath);
				}
				else
				{
					$moveworked=copy($origtnpath, $dest_tnpath);
				}
			}
		}
		
		foreach ($info_insertfields as $field)
		{	${$field}=EncloseOrNull(${$field}, "'");
		
			$output_query[$querychunk] .= "${$field}, ";
		}
		
		$output_query[$querychunk] = substr($output_query[$querychunk], 0, -2);
		$output_query[$querychunk] .= "), ";
			
		$len=strlen($output_query[$querychunk]);

		if ($len>50000)	//If the insert query reaches over 50 KB, then, we start another.
		{
			$output_query[$querychunk] = substr($output_query[$querychunk], 0, -2);
			$output_query[$querychunk] .= "  ";
			$prevquerychunk=$querychunk;
			$querychunk++;
		}
		$x++;
	}
	/*$no_images_present=true;
	if ($no_images_present)
	{
		unlink($exportdbtn_path);
	}*/
	
	
	$finaloutput_query=implode(" ", $output_query);
	$finaloutput_query = substr($finaloutput_query, 0, -2);
	$finaloutput_query .=";\n\n";

	$finalpath=$exportdb_path . "/$dbname";
		
	OverwriteFile($finalpath, $finaloutput_query, true);
}

?>